//+------------------------------------------------------------------+
//|                                                   Oma ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_level1 0

//
//
//
//
//

extern string TimeFrame       = "current time frame";
extern int    PriceToCompare  = PRICE_CLOSE;
extern double Oma1Period      = 20.55;
extern double Oma1Speed       = 2.0;
extern int    Oma1Price       = PRICE_CLOSE;
extern bool   Oma1Adaptive    = true;
extern double Oma2Period      = 50.85;
extern double Oma2Speed       = 0.0;
extern int    Oma2Price       = PRICE_CLOSE;
extern bool   Oma2Adaptive    = true;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsNotification = false;

//
//
//
//
//

double up[];
double dn[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   calculateValue;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,up); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
      if (Oma1Period>Oma2Period)
      {
         double temp = Oma1Period;
                       Oma1Period = Oma2Period;
                       Oma2Period = temp;
      }                    

      //
      //
      //
      //
      //
         
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");      if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue");  if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars)  { up[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      for(i=limit; i>=0; i--)
      {
         up[i]    = EMPTY_VALUE;
         dn[i]    = EMPTY_VALUE;
         trend[i] = 0;
            double oma1 = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Oma1Price,i),Oma1Period,Oma1Speed,Oma1Adaptive,i,0);
            double oma2 = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Oma2Price,i),Oma2Period,Oma2Speed,Oma2Adaptive,i,7);
            double price = iMA(NULL,0,1,0,MODE_SMA,PriceToCompare,i);
               if (price > MathMax(oma1,oma2)) trend[i] =  1;
               if (price < MathMin(oma1,oma2)) trend[i] = -1;
                  if (trend[i] ==  1) up[i] = price-MathMax(oma1,oma2);
                  if (trend[i] == -1) dn[i] = price-MathMin(oma1,oma2);
      }
      manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         up[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceToCompare,Oma1Period,Oma1Speed,Oma1Price,Oma1Adaptive,Oma2Period,Oma2Speed,Oma2Price,Oma2Adaptive,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,0,y);
         dn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceToCompare,Oma1Period,Oma1Speed,Oma1Price,Oma1Adaptive,Oma2Period,Oma2Speed,Oma2Price,Oma2Adaptive,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,1,y);
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"above both OMAs");
         if (trend[whichBar] == -1) doAlert(whichBar,"bellow both OMAs");
         if (trend[whichBar] ==  0) doAlert(whichBar,"in the middle");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," price is ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Oma ribbon histo"),message);
          if (alertsNotification) SendNotification(StringConcatenate(Symbol(),"Oma ribbon histo ",message));
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double stored[][14];

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iSmooth(double price, double averagePeriod, double tconst, bool adaptive, int i, int ashift=0)
{
   if (ArrayRange(stored,0) != Bars) ArrayResize(stored,Bars);
   if (averagePeriod <=1) return(price);
   int r = Bars-i-1; 
   
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res+ashift]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res+ashift]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+tconst)/(1.0+tconst+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}